Items - Create Report
Creates a report in the specified workspace.
This API supports long running operations (LRO).
The API supports two creation modes: (1) provide a definition for full control over the report structure, or (2) provide a creationPayload with a semanticModelReference to create an empty report connected to an existing semantic model. Either definition or creationPayload is required. You can't use both at the same time.
Permissions
The caller must have a contributor workspace role. When creating a report with a creationPayload that references a semantic model via semanticModelReference, the caller must also have read access to the referenced semantic model, including when that semantic model resides in a different workspace (cross-workspace reference).
Required Delegated Scopes
Report.ReadWrite.All or Item.ReadWrite.All
Limitations
- To create a report item, the user must have the appropriate license. For more information see: Microsoft Fabric license types.
Microsoft Entra supported identities
This API supports the Microsoft identities listed in this section.
| Identity | Support |
|---|---|
| User | Yes |
| Service principal and Managed identities | Yes |
Interface
POST https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/reports
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
workspace
|
path | True |
string (uuid) |
The workspace ID. |
Request Body
| Name | Required | Type | Description |
|---|---|---|---|
| displayName | True |
string |
The report display name. The display name must follow naming rules according to item type. |
| creationPayload |
The creation payload for creating a report connected to an existing semantic model. Either |
||
| definition |
The report public definition. Either |
||
| description |
string |
The report description. Maximum length is 256 characters. |
|
| folderId |
string (uuid) |
The folder ID. If not specified or null, the report is created with the workspace as its folder. |
|
| sensitivityLabelSettings |
The sensitivity label settings for the report. |
Responses
| Name | Type | Description |
|---|---|---|
| 201 Created |
Successfully created |
|
| 202 Accepted |
Request accepted, report provisioning in progress. Headers
|
|
| 429 Too Many Requests |
The service rate limit was exceeded. The server returns a Headers Retry-After: integer |
|
| Other Status Codes |
Common error codes:
|
Examples
| Create a report example |
| Create a report with creation payload example |
Create a report example
Sample request
POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/reports
{
"displayName": "Report 1",
"description": "A report description.",
"definition": {
"parts": [
{
"path": "definition.pbir",
"payload": "ew0KICAidmVyc2lvbiI..sYVN0eWxlTGl2ZSINCiAgICB9DQogIH0NCn0=",
"payloadType": "InlineBase64"
},
{
"path": "report.json",
"payload": "ewogICJjb25maWciOiA..3aWR0aCI6IDEyODAuMDAKICAgIH0KICBdCn0=",
"payloadType": "InlineBase64"
},
{
"path": ".platform",
"payload": "ZG90UGxhdGZvcm1CYXNlNjRTdHJpbmc=",
"payloadType": "InlineBase64"
}
]
}
}
Sample response
{
"displayName": "Report 1",
"description": "A report description.",
"type": "Report",
"workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
"id": "5b218778-e7a5-4d73-8187-f10824047715",
"sensitivityLabel": {
"id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
}
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30
Create a report with creation payload example
Sample request
POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/reports
{
"displayName": "Sales Dashboard",
"description": "An empty report connected to a semantic model.",
"creationPayload": {
"semanticModelReference": {
"referenceType": "ById",
"itemId": "5b218778-e7a5-4d73-8187-f10824047715",
"workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229"
}
}
}
Sample response
{
"displayName": "Sales Dashboard",
"description": "An empty report connected to a semantic model.",
"type": "Report",
"workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
"id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30
Definitions
| Name | Description |
|---|---|
|
Create |
Create report request payload. |
|
Entire |
Represents a tenant principal |
|
Error |
A structured parameter providing additional machine-readable context about an error. |
|
Error |
The error related resource details object. |
|
Error |
The error response. |
|
Error |
The error response details. |
|
Group |
Group specific details. Applicable when the principal type is |
|
Group |
Represents a security group. |
|
Group |
The type of the group. Additional group types may be added over time. |
|
Item |
An item reference by ID object. |
|
Item |
The item reference type. Additional |
|
Item |
Represents a tag applied on an item. |
|
Item |
The type of the item. Additional item types may be added over time. |
|
Payload |
The type of the definition part payload. Additional payload types may be added over time. |
|
Principal |
The type of the principal. Additional principal types may be added over time. |
| Report |
A report object. |
|
Report |
Creation payload for creating a report without a definition. |
|
Report |
Report public definition object. Refer to this article for more details on the structure of the Report definition. |
|
Report |
Report definition part object. |
|
Sensitivity |
Represents a sensitivity label applied to an item. |
|
Sensitivity |
The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time. |
|
Sensitivity |
The sensitivity label settings. |
|
Service |
Service principal specific details. Applicable when the principal type is |
|
Service |
Represents a Microsoft Entra service principal. |
|
Service |
Service principal profile details. Applicable when the principal type is |
|
Service |
Represents a service principal profile. |
|
User |
User principal specific details. Applicable when the principal type is |
|
User |
Represents a Microsoft Entra user principal. |
CreateReportRequest
Create report request payload.
| Name | Type | Description |
|---|---|---|
| creationPayload |
The creation payload for creating a report connected to an existing semantic model. Either |
|
| definition |
The report public definition. Either |
|
| description |
string |
The report description. Maximum length is 256 characters. |
| displayName |
string |
The report display name. The display name must follow naming rules according to item type. |
| folderId |
string (uuid) |
The folder ID. If not specified or null, the report is created with the workspace as its folder. |
| sensitivityLabelSettings |
The sensitivity label settings for the report. |
EntireTenantPrincipal
Represents a tenant principal
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| type |
string:
Entire |
The type of the principal. Additional principal types may be added over time. |
ErrorParameter
A structured parameter providing additional machine-readable context about an error.
| Name | Type | Description |
|---|---|---|
| message |
string |
A human-readable description of the parameter's meaning. |
| name |
string |
The parameter identifier. |
| value |
string |
The parameter value. |
ErrorRelatedResource
The error related resource details object.
| Name | Type | Description |
|---|---|---|
| resourceId |
string |
The resource ID that's involved in the error. |
| resourceType |
string |
The type of the resource that's involved in the error. |
ErrorResponse
The error response.
| Name | Type | Description |
|---|---|---|
| errorCode |
string |
A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users. |
| isRetriable |
boolean |
When true, the request can be retried. Use the |
| message |
string |
A human readable representation of the error. |
| moreDetails |
List of additional error details. |
|
| parameters |
Structured parameters providing additional machine-readable context about the error. |
|
| relatedResource |
The error related resource details. |
|
| requestId |
string (uuid) |
ID of the request associated with the error. |
ErrorResponseDetails
The error response details.
| Name | Type | Description |
|---|---|---|
| errorCode |
string |
A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users. |
| message |
string |
A human readable representation of the error. |
| parameters |
Structured parameters providing additional machine-readable context about the error. |
|
| relatedResource |
The error related resource details. |
GroupDetails
Group specific details. Applicable when the principal type is Group.
| Name | Type | Description |
|---|---|---|
| groupType |
The type of the group. Additional group types may be added over time. |
GroupPrincipal
Represents a security group.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| groupDetails |
Group specific details. Applicable when the principal type is |
|
| id |
string (uuid) |
The principal's ID. |
| type |
string:
Group |
The type of the principal. Additional principal types may be added over time. |
GroupType
The type of the group. Additional group types may be added over time.
| Value | Description |
|---|---|
| Unknown |
Principal group type is unknown. |
| SecurityGroup |
Principal is a security group. |
| DistributionList |
Principal is a distribution list. |
ItemReferenceById
An item reference by ID object.
| Name | Type | Description |
|---|---|---|
| itemId |
string (uuid) |
The ID of the item. |
| referenceType |
string:
By |
The item reference type. |
| workspaceId |
string (uuid) |
The workspace ID of the item. |
ItemReferenceType
The item reference type. Additional ItemReferenceType types may be added over time.
| Value | Description |
|---|---|
| ById |
The item is referenced by its ID. |
| ByVariable |
The item is referenced by a variable. |
ItemTag
Represents a tag applied on an item.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The name of the tag. |
| id |
string (uuid) |
The tag ID. |
ItemType
The type of the item. Additional item types may be added over time.
| Value | Description |
|---|---|
| Dashboard |
PowerBI dashboard. |
| Report |
PowerBI report. |
| SemanticModel |
PowerBI semantic model. |
| PaginatedReport |
PowerBI paginated report. |
| Datamart |
PowerBI datamart. |
| Lakehouse |
A lakehouse. |
| Eventhouse |
An eventhouse. |
| Environment |
An environment. |
| KQLDatabase |
A KQL database. |
| KQLQueryset |
A KQL queryset. |
| KQLDashboard |
A KQL dashboard. |
| DataPipeline |
A data pipeline. |
| Notebook |
A notebook. |
| SparkJobDefinition |
A spark job definition. |
| MLExperiment |
A machine learning experiment. |
| MLModel |
A machine learning model. |
| Warehouse |
A warehouse. |
| Eventstream |
An eventstream. |
| SQLEndpoint |
An SQL endpoint. |
| MirroredWarehouse |
A mirrored warehouse. |
| MirroredDatabase |
A mirrored database. |
| Reflex |
A Reflex. |
| GraphQLApi |
An API for GraphQL item. |
| MountedDataFactory |
A MountedDataFactory. |
| SQLDatabase |
A SQLDatabase. |
| CopyJob |
A Copy job. |
| VariableLibrary |
A VariableLibrary. |
| Dataflow |
A Dataflow. |
| ApacheAirflowJob |
An ApacheAirflowJob. |
| WarehouseSnapshot |
A Warehouse snapshot. |
| DigitalTwinBuilder |
A DigitalTwinBuilder. |
| DigitalTwinBuilderFlow |
A Digital Twin Builder Flow. |
| MirroredAzureDatabricksCatalog |
A mirrored azure databricks catalog. |
| Map |
A Map. |
| AnomalyDetector |
An Anomaly Detector. |
| UserDataFunction |
A User Data Function. |
| GraphModel |
A GraphModel. |
| GraphQuerySet |
A Graph QuerySet. |
| SnowflakeDatabase |
A Snowflake Database to store Iceberg tables created from Snowflake account. |
| OperationsAgent |
A OperationsAgent. |
| CosmosDBDatabase |
A Cosmos DB Database. |
| Ontology |
An Ontology. |
| EventSchemaSet |
An EventSchemaSet. |
| DataAgent |
A DataAgent. |
| MirroredCatalog |
A MirroredCatalog. |
| PolicySet |
A PolicySet. |
| AppBackend |
An AppBackend. |
| OrgApp |
An Org App. |
| OrgAppAudience |
An Org App Audience. |
| DataBuildToolJob |
A DataBuildToolJob. |
| AzureDatabricksStorage |
A OneLake-backed storage item for Azure Databricks. |
| Plan |
A plan. |
| Monitoring |
A Monitoring item. |
| DeploymentPlan |
A Deployment plan. |
| ShareSubscription |
A Share Subscription. |
| Share |
A share. |
PayloadType
The type of the definition part payload. Additional payload types may be added over time.
| Value | Description |
|---|---|
| InlineBase64 |
Inline Base 64. |
PrincipalType
The type of the principal. Additional principal types may be added over time.
| Value | Description |
|---|---|
| User |
Principal is a Microsoft Entra user principal. |
| ServicePrincipal |
Principal is a Microsoft Entra service principal. |
| Group |
Principal is a security group. |
| ServicePrincipalProfile |
Principal is a service principal profile. |
| EntireTenant |
Principal represents all tenant users. |
Report
A report object.
| Name | Type | Description |
|---|---|---|
| defaultIdentity | Principal: |
The item's default identity. |
| description |
string |
The item description. |
| displayName |
string |
The item display name. |
| folderId |
string (uuid) |
The folder ID. |
| id |
string (uuid) |
The item ID. |
| logicalId |
string (uuid) |
The item's logical identifier. Corresponding item instances share the same logical ID. The value is null when no logical ID has been assigned. |
| sensitivityLabel |
The item sensitivity label. |
|
| tags |
Item |
List of applied tags. |
| type |
The item type. |
|
| workspaceId |
string (uuid) |
The workspace ID. |
ReportCreationPayload
Creation payload for creating a report without a definition.
| Name | Type | Description |
|---|---|---|
| semanticModelReference |
A reference to the semantic model to connect the report to. The semantic model must be accessible to the caller. |
ReportDefinition
Report public definition object. Refer to this article for more details on the structure of the Report definition.
| Name | Type | Description |
|---|---|---|
| format |
string |
The format of the report definition. |
| parts |
A list of definition parts. |
ReportDefinitionPart
Report definition part object.
| Name | Type | Description |
|---|---|---|
| path |
string |
The report part path. |
| payload |
string |
The report part payload. |
| payloadType |
The payload type. |
SensitivityLabel
Represents a sensitivity label applied to an item.
| Name | Type | Description |
|---|---|---|
| id |
string (uuid) |
The sensitivity label ID. |
SensitivityLabelApplyStrategy
The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.
| Value | Description |
|---|---|
| ApplyOrFail |
Apply the sensitivity label or fail the operation if it cannot be applied. |
| Ignore |
Ignore the sensitivity label if it cannot be applied and proceed with the operation without applying the label. |
SensitivityLabelSettings
The sensitivity label settings.
| Name | Type | Description |
|---|---|---|
| labelId |
string (uuid) |
The sensitivity label ID. |
| sensitivityLabelApplyStrategy |
The strategy for applying the sensitivity label. |
ServicePrincipalDetails
Service principal specific details. Applicable when the principal type is ServicePrincipal.
| Name | Type | Description |
|---|---|---|
| aadAppId |
string (uuid) |
The service principal's Microsoft Entra AppId. |
ServicePrincipalPrincipal
Represents a Microsoft Entra service principal.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| servicePrincipalDetails |
Service principal specific details. Applicable when the principal type is |
|
| type |
string:
Service |
The type of the principal. Additional principal types may be added over time. |
ServicePrincipalProfileDetails
Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.
| Name | Type | Description |
|---|---|---|
| parentPrincipal | Principal: |
The service principal profile's parent principal. |
ServicePrincipalProfilePrincipal
Represents a service principal profile.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| servicePrincipalProfileDetails |
Service principal profile details. Applicable when the principal type is |
|
| type |
string:
Service |
The type of the principal. Additional principal types may be added over time. |
UserDetails
User principal specific details. Applicable when the principal type is User.
| Name | Type | Description |
|---|---|---|
| userPrincipalName |
string |
The user principal name. |
UserPrincipal
Represents a Microsoft Entra user principal.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| type |
string:
User |
The type of the principal. Additional principal types may be added over time. |
| userDetails |
User principal specific details. Applicable when the principal type is |